ig.module(
    'game.entities.base'
)
.requires(
    'game.extensions.constants',
    'impact.entity'
)
.defines(function () {
    EntityBase = ig.Entity.extend({
        size: {x: ig.settings.sprite * ig.settings.pScale, y: ig.settings.sprite * ig.settings.pScale},
        offset: {x: 0 * ig.settings.pScale, y: 0 * ig.settings.pScale},
        
        collides: ig.Entity.COLLIDES.NEVER,

        type: ig.Entity.TYPE.NONE,

        frameOffset: 0, // Frame offset for defining animations

        animSheet: new ig.AnimationSheet('media/sprites.png', ig.settings.sprite * ig.settings.pScale, ig.settings.sprite * ig.settings.pScale),
        
        zIndex: 10,
        
        init: function (x, y, settings) {
            this.parent(x, y, settings);

            this.createAnimations();
        },
        
        createAnimations: function () {
            this.addAnim('idle', 1, [0]);
        },
        
        addAnim: function (name, frameTime, sequence, stop) {
            for (var i = 0; i < sequence.length; i++) {
                sequence[i] += this.frameOffset;
            }
            
            return this.parent(name, frameTime, sequence, stop);
    	},
        
        update: function () {
            if (ig.game.freeze) {
            }
            
            this.determineAnim();

            this.parent();
        },
        
        determineAnim: function () {
            this.currentAnim = this.anims.idle;
        }
    });
});