ig.module(
    'game.entities.character'
)
.requires(
    'game.entities.base'
)
.defines(function () {
    EntityCharacter = EntityBase.extend({
        collides: ig.Entity.COLLIDES.FIXED,
        
        type: ig.Entity.TYPE.B,
        
        flip: false,
        showFlip: true,
        
        friction: {x: 0, y: 0},
        
        zIndex: 30,
        
        init: function (x, y, settings) {
            this.parent(x, y, settings);
            
            if (typeof this.name == 'undefined') {
                this.name = 'id' + this.id;
            }
        },
        
        update: function () {
            if (ig.game.freeze) {
                this.vel.x = 0;
                this.vel.y = 0;
            }
            
            if (this.vel.x > 0) {
                this.flip = true;
                
            } else if (this.vel.x < 0) {
                this.flip = false;
            }

            if (this.showFlip) {
                this.currentAnim.flip.x = this.flip;
            }

            this.parent();
        }
    });
});