ig.module(
    'game.entities.dawkins'
)
.requires(
    'game.entities.base'
)
.defines(function () {
    EntityDawkins = EntityBase.extend({
        collides: ig.Entity.COLLIDES.NEVER,
        
        type: ig.Entity.TYPE.A,
        
        frameOffset: 2,
        
        what: 'dawkins',
        
        showFlip: false,
        
        zIndex: 40,
        
    	maxVel: {x: 10000, y: 10000},
    	
    	vx: 0,
    	vy: 0,
    	vTimer: new ig.Timer(1.0),
    	atEnd: true,
        
        init: function (x, y, settings) {
            this.parent(x, y, settings);
            
            if (ig.game.setCellEntityXY) {
                ig.game.setCellEntityXY(this, this.pos.x, this.pos.y);
            }
        },
        
        createAnimations: function () {
            this.addAnim('idle', 0.25, [0, 1, 0, 1]);
        },
        
        update: function () {
            if (ig.game.freeze) {
                this.parent();
                return;
            }
            
            var dx = 0, dy = 0, myCell, ent;
            
            myCell = ig.game.getCell(this.pos.x, this.pos.y);
            
            if (this.vTimer.delta() >= 0) {
                this.vTimer.reset();
                
                if (myCell.col == 0) {
                    if (this.atEnd) {
                        this.vx = 1;
                        this.vy = 0;
                        this.atEnd = false;
                        
                    } else {
                        this.vx = 0;
                        this.vy = 1;
                        this.atEnd = true;
                    }
                } else if (myCell.col == ig.settings.cols - 1) {
                    if (this.atEnd) {
                        this.vx = -1;
                        this.vy = 0;
                        this.atEnd = false;
                        
                    } else {
                        this.vx = 0;
                        this.vy = 1;
                        this.atEnd = true;
                    }
                }
                
                dx = this.vx;
                dy = this.vy;
            }
            
            
            if (dx || dy) {
                ent = ig.game.setCellEntity(this, myCell.col + dx, myCell.row + dy);
                ig.game.setCellEntity(ent, myCell.col, myCell.row);
                if (ent) {/// && ent.what != 'player') {
                    if (ent.bad) {
                        ig.stage = 'gameover';
                    }
                    
                    ent.kill();
                    ig.game.setCellEntity(null, myCell.col, myCell.row);
                }
            }
            
            this.parent();
        }
    });
});