ig.module(
    'game.entities.player'
)
.requires(
    'game.entities.character'
)
.defines(function () {
    EntityPlayer = EntityCharacter.extend({
        collides: ig.Entity.COLLIDES.NEVER,
        
        type: ig.Entity.TYPE.A,
        
        frameOffset: 0,
        
        what: 'player',
        
        showFlip: false,
        
        zIndex: 30,
        
    	maxVel: {x: 10000, y: 10000},
        
        moveTimer: new ig.Timer(),
        
        instructionsArrowPresses: 0,
        
        init: function (x, y, settings) {
            this.parent(x, y, settings);
            
            if (ig.game.setCellEntityXY) {
                ig.game.setCellEntityXY(this, this.pos.x, this.pos.y);
            }
        },
        
        createAnimations: function () {
            this.addAnim('idle', 0.25, [0, 1, 0, 1]);
        },
        
        update: function () {
            var ent, mCell, pCell, dx = 0, dy = 0;
            
            /*
            if (ig.input.pressed('arrange')) {
                mCell = ig.game.getCell(ig.input.mouse.x, ig.input.mouse.y);
                pCell = ig.game.getCell(this.pos.x, this.pos.y);
                
                // Left
                if (mCell.col == pCell.col - 1 && mCell.row == pCell.row) {                   
                    ent = ig.game.setCellEntity(this, pCell.col - 1, pCell.row);
                    ent = ig.game.setCellEntity(ent, pCell.col - 1, pCell.row - 1);
                    ent = ig.game.setCellEntity(ent, pCell.col, pCell.row - 1);
                    ig.game.setCellEntity(ent, pCell.col, pCell.row);
                
                // Up
                } else if (mCell.col == pCell.col && mCell.row == pCell.row - 1) {
                    ent = ig.game.setCellEntity(this, pCell.col, pCell.row - 1);
                    ent = ig.game.setCellEntity(ent, pCell.col + 1, pCell.row - 1);
                    ent = ig.game.setCellEntity(ent, pCell.col + 1, pCell.row);
                    ig.game.setCellEntity(ent, pCell.col, pCell.row);
                
                // Down
                } else if (mCell.col == pCell.col && mCell.row == pCell.row + 1) {
                    ent = ig.game.setCellEntity(this, pCell.col, pCell.row + 1);
                    ent = ig.game.setCellEntity(ent, pCell.col - 1, pCell.row + 1);
                    ent = ig.game.setCellEntity(ent, pCell.col - 1, pCell.row);
                    ig.game.setCellEntity(ent, pCell.col, pCell.row);
                
                // Right
                }  else if (mCell.col == pCell.col + 1 && mCell.row == pCell.row) {
                    ent = ig.game.setCellEntity(this, pCell.col + 1, pCell.row);
                    ent = ig.game.setCellEntity(ent, pCell.col + 1, pCell.row + 1);
                    ent = ig.game.setCellEntity(ent, pCell.col, pCell.row + 1);
                    ig.game.setCellEntity(ent, pCell.col, pCell.row);
                }
            }
            */
            
            
            /*
            pCell = ig.game.getCell(this.pos.x, this.pos.y);
            
            if (ig.input.pressed('left')) {
                ent = ig.game.setCellEntity(this, pCell.col - 1, pCell.row);
                ent = ig.game.setCellEntity(ent, pCell.col - 2, pCell.row);
                ent = ig.game.setCellEntity(ent, pCell.col - 3, pCell.row);
                ent = ig.game.setCellEntity(ent, pCell.col - 4, pCell.row);
                ig.game.setCellEntity(ent, pCell.col - 5, pCell.row);
            
            } else if (ig.input.pressed('right')) {
                ent = ig.game.setCellEntity(this, pCell.col + 1, pCell.row);
                ent = ig.game.setCellEntity(ent, pCell.col + 2, pCell.row);
                ent = ig.game.setCellEntity(ent, pCell.col + 3, pCell.row);
                ent = ig.game.setCellEntity(ent, pCell.col + 4, pCell.row);
                ig.game.setCellEntity(ent, pCell.col + 5, pCell.row);
            
            } else if (ig.input.pressed('up')) {
                ent = ig.game.setCellEntity(this, pCell.col, pCell.row - 1);
                ent = ig.game.setCellEntity(ent, pCell.col, pCell.row - 2);
                ent = ig.game.setCellEntity(ent, pCell.col, pCell.row - 3);
                ent = ig.game.setCellEntity(ent, pCell.col, pCell.row - 4);
                ig.game.setCellEntity(ent, pCell.col, pCell.row - 5);
            
            } else if (ig.input.pressed('down')) {
                ent = ig.game.setCellEntity(this, pCell.col, pCell.row + 1);
                ent = ig.game.setCellEntity(ent, pCell.col, pCell.row + 2);
                ent = ig.game.setCellEntity(ent, pCell.col, pCell.row + 3);
                ent = ig.game.setCellEntity(ent, pCell.col, pCell.row + 4);
                ig.game.setCellEntity(ent, pCell.col, pCell.row + 5);
            }
            */
            
            if (ig.stage == 'instructions') {
                if (ig.input.pressed('left') || ig.input.pressed('right') || ig.input.pressed('up') || ig.input.pressed('down')) {
                    this.instructionsArrowPresses++;
                }
                
                if (ig.input.pressed('x') || this.instructionsArrowPresses > 0) {
                    ig.game.freeze = false;
                    ig.stage = 'play';
                }
            }
            
            if (ig.game.freeze) {
                this.parent();
                return;
            }
            
            var dx = 0, dy = 0;
            
            if (ig.input.pressed('left')) {
                dx = -1;
            
            } else if (ig.input.pressed('right')) {
                dx = 1;
            
            } else if (ig.input.pressed('up')) {
                dy = -1;
            
            } else if (ig.input.pressed('down')) {
                dy = 1;
            }
            
            pCell = ig.game.getCell(this.pos.x, this.pos.y);
            ent = ig.game.getCellEntity(pCell.col + dx, pCell.row + dy);
            
            if (ent && ent.what != 'dawkins' && (dx || dy)) {/// && (pCell.row + dy >= 0 && pCell.row + dy < ig.settings.rows)) {
                ent = ig.game.setCellEntity(this, pCell.col + dx, pCell.row + dy);
                ig.game.setCellEntity(ent, pCell.col, pCell.row);
            }
            
            this.parent();
        },
        
        kill: function () {
            ig.stage = 'gameover2';
            
            this.parent();
        },
        
        // Disabling default collision with tilemap
        handleMovementTrace: function () {}
    });
});