/**
 * Game code, graphics, and story are Copyright (c) 2012 Zachstronaut LLC. All rights reserved.
 */


/**



IDEA: more difficult levels could have solid, unmovable blocks to make things more challenging?
        other ways to enrich the ordering mechanic?
        
        
        
        bonus points for correct arrangement within layer?
        
        
        
        if used background map instead of row # to determine correct placement, could have uneven layers to add difficulty/break things up
        
        
[ ] graphics
[ ] a few levels of increasing difficulty, or procedural level generation
[ ] sound?

**/

/**

BRAINSTORM NOTES:

puzzle game: you play god in the year 4000 BC... and you have to burry fossils in the ground in the correct order to test the faith of mankind

action game... scientists digging from top like dig dug... ground is full of fossils and you must like do tile swapping or something to rearrange them... or you have inventory of fossils that you must place in the right order... such that as scientist keeps digging things stay in evolutionary order...
or maybe scientist clears row by row rather than digging straight down in a column... it is your timer essentially, because if they run into something that is incorrect ... game over
there could be bonus points for connected fossils... where you have matching parts across adjacent tiles
could start with populated layers with fossils all nicely laid out and then run scramble algorithm... # of scramble moves is proportional to difficulty which is really nice.  so it is just an unscramble game really.
if things are too easy swapping any two adjacent tiles, you could do like a "rotation" swap of an adjacent 4
Use a walk-to-rearrange mechanic?
or maybe god is punishing darwin's ghost, who has to keep things in evolutionary order as punishment for the theory


another idea would be a sliding block puzzle... http://en.wikipedia.org/wiki/Klotski ... dirt blocks and fossil blocks, get them in the right order.  but then it is literally just a game people have played a billion times with a funny skin/story... maybe that's good enough?


tetris style?  pieces come up from bottom... have to make layers of consistent fossils... scientists dig from above to clear rows consistent with evolution... ok but then you'd have to keep "holes" open to drop in fossils from the right era... that doesn't seem quite right

rearrange-the-9 style? less of a game, more of an algorithm you apply

towers of hanoi... got two heaven stacks and one earth stack... have to rearrange fossil layers from heaven into earth in correct order... not really a game though, you just apply an algorithm to solve

**/


ig.module( 
	'game.main' 
)
.requires(
	'impact.game',
	'impact.font',
	//'impact.debug.debug',
	
	'game.extensions.constants',
	
	'game.entities.player',
	
	'game.levels.map1',
	'game.levels.map2',
	'game.levels.map3'
)
.defines(function () {

MyGame = ig.Game.extend({
	// Load a font
	fontHUD: new ig.Font('media/04b03.font.png'),

	// Store a shortcut to player entity
	player: null,

	freeze: false, // true to stop all Entities in their tracks

    cells: [
        [],
        [],
        [],
        [],
        [],
        [],
        [],
        [],
        [],
        []
    ],
    
    setCellEntity: function (entity, col, row) {        
        while (col < 0) {
            col += ig.settings.cols;
        }
        col = col % ig.settings.cols;
        while (row < 0) {
            row += ig.settings.rows;
        }
        row = row % ig.settings.rows;
        
        var prevEntity = this.cells[row][col];
        
        if (entity) {
            entity.pos.x = col * ig.settings.sprite;
            entity.pos.y = row * ig.settings.sprite;
        }
        
        this.cells[row][col] = entity;
        
        return prevEntity;
    },
    
    setCellEntityXY: function (entity, x, y) {
        var p = this.getCell(x, y);
        return this.setCellEntity(entity, p.col, p.row);
    },
    
    getCellEntity: function(col, row) {
        while (col < 0) {
            col += ig.settings.cols;
        }
        col = col % ig.settings.cols;
        while (row < 0) {
            row += ig.settings.rows;
        }
        row = row % ig.settings.rows;
        
        return this.cells[row][col];
    },
    
    getCell: function (x, y) {
        return {col: Math.floor(x / ig.settings.sprite), row: Math.floor(y / ig.settings.sprite)};
    },
    
    getSurroundingCellsXY: function (x, y) {
        var row,
            col,
            cy = Math.floor(y / ig.settings.sprite),
            cx = Math.floor(x / ig.settings.sprite),
            cells = [];
        
        for (row = -1; row <= 1; row++) {
            for (col = -1; col <= 1; col++) {
                if (row != 0 || col != 0) {
                    if (cy + row >= 0 && cy + row < ig.settings.rows && cx + col >= 0 && cx + col < ig.settings.cols) {
                        cells.push(this.cells[cy + row][cx + col]);
                        
                    } else {
                        cells.push(null);
                    }
                }
            }
        }
        
        return cells;
    },

	init: function () {
	    // My debug defaults
	    ig.Entity._debugShowBoxes = true;
        ig.Entity._debugShowVelocities = true;
        ig.Entity._debugShowNames = true;

		// BGM		
        /// if (typeof ig.DebugGraphPanel == 'undefined') {
        //     ig.music.add('media/sounds/bgm1.*');
        //          ig.music.loop = true;
        //          ig.music.volume = 0.5;
        //          ig.music.play();
        // }

		// Initialize your game here; bind keys etc.
        ig.input.bind(ig.KEY.UP_ARROW, 'up');
        ig.input.bind(ig.KEY.DOWN_ARROW, 'down');
        ig.input.bind(ig.KEY.LEFT_ARROW, 'left');
        ig.input.bind(ig.KEY.RIGHT_ARROW, 'right');
        ig.input.bind(ig.KEY.W, 'up');
        ig.input.bind(ig.KEY.S, 'down');
        ig.input.bind(ig.KEY.A, 'left');
        ig.input.bind(ig.KEY.D, 'right');
		ig.input.bind(ig.KEY.X, 'x');
		
		// ig.input.bind(ig.KEY.MOUSE1, 'arrange');        

		ig.system.halfWidth = ig.system.width / 2;
		ig.system.halfHeight = ig.system.height / 2;

        this.levels = [LevelMap1, LevelMap2, LevelMap3];

        this.currentLevel = 0;
		this.loadLevel(this.levels[this.currentLevel]);

		this.player = this.getEntitiesByType(EntityPlayer)[0];
	},

	update: function () {
		// Update all entities and backgroundMaps
		this.parent();

		// Add your own, additional update code here
	},

	draw: function () {
		// Draw all entities and backgroundMaps
		this.parent();

		// Add your own drawing code here
        
        if (ig.stage != 'play') {
            ig.game.freeze = true;
            
            ig.system.context.fillStyle = 'rgba(0, 0, 0, 0.8)';
            ig.system.context.fillRect(0, 0, ig.system.realWidth, ig.system.realHeight);
            
            if (ig.stage == 'instructions') {
                // this.fontHUD.draw("You are Darwin's ghost!  You must test the", 8, 8*1);
                // this.fontHUD.draw("scientist's faith by reordering fossils in layers", 8, 8*3);
                // this.fontHUD.draw("according to your theory of evolution. ", 8, 8*5);
                // this.fontHUD.draw("Make sure each fossil is in the correct color layer", 8, 8*7);
                // this.fontHUD.draw("before the scientist digs it up.", 8, 8*9);
            
                ig.system.context.globalAlpha = 0.7;
                this.fontHUD.draw("You are Darwin's ghost!  You must rearrange", 8, 8*3);
                this.fontHUD.draw("fossils in layers according to your theory of", 8, 8*5);
                this.fontHUD.draw("evolution before the scientist digs them up!", 8, 8*7);

                ig.system.context.globalAlpha = 1.0;
                this.fontHUD.draw("* MOVE with your keyboard ARROW KEYS or WASD. *", 8, 8*13);
                
                ig.system.context.globalAlpha = 0.7;
                this.fontHUD.draw("As you move, tiles will swap positions with Darwin.", 8, 8*15);
                this.fontHUD.draw("Match fossil color with layer color. ", 8, 8*17);
            
            } else if (ig.stage == 'levelwin' || ig.stage == 'levelperfect') {
                if (ig.stage == 'levelperfect') {
                    this.fontHUD.draw("             PERFECT BONES BONUS!!!", 8, 8*7);
                    
                } else {
                    ig.system.context.globalAlpha = 0.7;
                    this.fontHUD.draw("                  Nice work!", 8, 8*7);
                }
                
                ig.system.context.globalAlpha = 0.7;
                this.fontHUD.draw("      Fossils buried according to evolution.", 8, 8*11);
                this.fontHUD.draw("      Another scientist fooled... Darwin FTW!", 8, 8*13);
                
                ig.system.context.globalAlpha = 1.0;
                this.fontHUD.draw("           Press `X' for next level...", 8, 8*15);
                
                if (ig.input.pressed('x')) {
                    if (this.currentLevel + 1 < this.levels.length) {
                        ig.newLevel(this.currentLevel + 1);
                        
                    }
                }
            
            } else if (ig.stage == 'gamewin') {
                this.fontHUD.draw("     A winner is you!  Thanks for playing!!!", 8, 8*7);
                this.fontHUD.draw("  This is as much game as I could make for you", 8, 8*11);
                this.fontHUD.draw("  in 48 hours for Ludum Dare 24: \"Evolution\".", 8, 8*13);
                this.fontHUD.draw("  Let me know if you want to see more!", 8, 8*15);
            
            } else if (ig.stage == 'gameover') {
                ig.system.context.globalAlpha = 0.7;
                this.fontHUD.draw("        \"This fossil proves Darwin wrong!\"", 8, 8*7);
                this.fontHUD.draw("                  GAME OVER!", 8, 8*11);
                
                ig.system.context.globalAlpha = 1.0;
                this.fontHUD.draw("            Press `X' to try again...", 8, 8*13);
                
                if (ig.input.pressed('x')) {
                    this.loadLevel(this.levels[this.currentLevel]);
                    ig.newGame();
                }
                
            } else if (ig.stage == 'gameover2') {
                ig.system.context.globalAlpha = 0.7;
                this.fontHUD.draw("            \"I think I saw a ghost!\"", 8, 8*7);
                this.fontHUD.draw("                  GAME OVER!", 8, 8*11);
                
                ig.system.context.globalAlpha = 1.0;
                this.fontHUD.draw("            Press `X' to try again...", 8, 8*13);
                
                if (ig.input.pressed('x')) {
                    this.loadLevel(this.levels[this.currentLevel]);
                    ig.newGame();
                }
            }
            
            ig.system.context.globalAlpha = 1.0;
        }
	}
});


// Start the Game
ig.main('#canvas', MyGame, 60, ig.settings.width, ig.settings.height, 4);

});
